#include <stdlib.h>
#include <tk.h>
#include <gr/tiffio.h>
#include <X11/Xproto.h>


int TkReadTIFFFile(Tk_Window tkwin,char *string,int *width,int *height, Pixmap *pixmap,int scale) {
u_char *p;
static XGCValues gc_values;
XImage *xImage;
GC bitmap_gc;
int i,j;
u_char * imageMemory;
u_short tfBitsPerSample, tfBytesPerRow;
static unsigned char t1[]={1,2,4,8,16,32,64,128};
static unsigned char t2[]={128,64,32,16,8,4,2,1};
static unsigned char t3[]={~1,~2,~4,~8,~16,~32,~64,~128};
static unsigned char t4[]={~128,~64,~32,~16,~8,~4,~2,~1};
TIFF *tfFile;
  if(!(tfFile=TIFFOpen(string,"r"))) return 0;
  if(TIFFReadDirectory(tfFile)==True) { TIFFSetDirectory(tfFile,0); }
  TIFFGetField(tfFile, TIFFTAG_IMAGEWIDTH, width);
  TIFFGetField(tfFile, TIFFTAG_IMAGELENGTH, height);
  if (!TIFFGetField(tfFile, TIFFTAG_BITSPERSAMPLE, &tfBitsPerSample)) tfBitsPerSample = 1;
  tfBytesPerRow= TIFFScanlineSize(tfFile);
  if ( tfBitsPerSample !=1 || *height<=0 || *width <=0  || tfBytesPerRow <=0) return 0;
  imageMemory=(u_char *)ckalloc((tfBytesPerRow) * ((*height)));
  for (p=imageMemory,i=0;i<(*height);i++,p+=tfBytesPerRow) {
    if(TIFFReadScanline(tfFile,p,i,0)<0) break;
  }
  TIFFClose(tfFile);
  if(scale) {
    *width/=2;
    *height/=2;
    for(i=0;i<(*height);i++) {
      for(j=0;j<(*width);j++) {
        int x00=imageMemory[((2*i+0)*tfBytesPerRow)+((2*j+0)>>3)] & t2[(2*j+0)&7];
        int x01=imageMemory[((2*i+1)*tfBytesPerRow)+((2*j+0)>>3)] & t2[(2*j+0)&7];
        int x10=imageMemory[((2*i+0)*tfBytesPerRow)+((2*j+1)>>3)] & t2[(2*j+1)&7];
        int x11=imageMemory[((2*i+1)*tfBytesPerRow)+((2*j+1)>>3)] & t2[(2*j+1)&7];
        int count=(x00?1:0)+(x01?1:0)+(x10?1:0)+(x11?1:0);
        imageMemory[i*tfBytesPerRow+(j>>3)]&=t4[j&7];
        if(count>1) {
          imageMemory[i*tfBytesPerRow+(j>>3)]|=t2[j&7];
        }
      }
    }
  } 
  xImage = XCreateImage(Tk_Display(tkwin),Tk_Visual(tkwin),1,XYBitmap,0,(char *)imageMemory,(*width),(*height),8,tfBytesPerRow);
  xImage->bitmap_bit_order = MSBFirst;
  xImage->byte_order = MSBFirst;
  *pixmap = XCreatePixmap(Tk_Display(tkwin), RootWindowOfScreen(Tk_Screen(tkwin)), xImage->width, xImage->height, 1);
  gc_values.function = GXcopy;
  gc_values.plane_mask = AllPlanes;
  gc_values.foreground = 1;
  gc_values.background = 0;
  bitmap_gc = XCreateGC(Tk_Display(tkwin), *pixmap, GCForeground | GCBackground, &gc_values);
  XPutImage(Tk_Display(tkwin), *pixmap, bitmap_gc, xImage, 0, 0, 0, 0, xImage->width, xImage->height);
  XFreeGC(Tk_Display(tkwin),bitmap_gc);
  XDestroyImage(xImage);
  /* ckfree(imageMemory); Freed by XDestroyImage */
  return 1;
}

